
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputErrLexer.g.
 * /!\ Don't edit it!
 */

#ifndef LGCOUTPUTLERRLEXER_HPP
#define LGCOUTPUTLERRLEXER_HPP

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "LGCMeasures.hpp"

#include "table_lgcoutputerrlexer_p.h"

class LGCOutputErrLexer : public LexerParser<Table_LGCOutputErrLexer>
{
	Q_OBJECT

public:
	LGCOutputErrLexer(QObject *parent = nullptr);
	virtual ~LGCOutputErrLexer() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		Normal,
		Comment,
		/** Values */
		ValueImportant,
		ValueError,
		ValueCorrect,
		/** Table */
		TablePoint,
		TableHeader,
		TableHeaderUnits,
		TableFrameTransformation,
		/** Frames */
		Frame,
		FrameName,
		/** Overall Reliability */
		OverallReliability,
	};
	/**
	 * Uses the input measures to create links between input and output file.
	 *
	 * @warning This method must be called before opening the output file.
	 */
	void lgcMeasures(LGCMeasures measures) noexcept
	{
		_inputData = std::move(measures);
		_inputData.instruments.clear();
		_inputData.measures.clear();
		_inputData.targets.clear();
	}
	const LGCMeasures &lgcMeasures() const noexcept { return _inputData; }
	// implemented in LGCOutputErrLexer_impl.cpp
	virtual const char *language() const override { return "LGCPointErr"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in LGCOutputErrLexer_impl.cpp
	virtual const std::string &getMIMEType() const override { static std::string _tmp = ""; return _tmp; }
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &) override { return std::string(); }
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &) override { return std::string(); }
	virtual std::string write(const ShareableParams &) override { return std::string(); }
	virtual std::string write(const ShareablePoint &) override { return std::string(); }
	virtual std::string write(const ShareablePosition &) override { return std::string(); }

protected:
	// TextLexer
	// implemented in LGCOutputErrLexer_impl.cpp
	virtual QString calltip(int position, int indicatorType, const QString &indicator) const override;

private:
	// LexerParser
	// generated in in LGCOutputErrLexer_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;
	
	/** used in lexer */
	void checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK = Styles::Normal, Styles styleError = Styles::ValueError);
	
	// implemented in LGCOutputErrLexer_impl.cpp
	/** Called each time we meet a point name */
	void setPoint(QStringRef sym);
	/** Called each time we meet a frame name */
	void setFrame(QStringRef sym);

private:
	/** input measures */
	LGCMeasures _inputData;
	/** TMP variable. Used for parsing */
	/** Temporary ints used for frame folding based on ID */
	int _curTmpFrameLevel;
	int _curTmpFrameLevelNext;
};

#endif // LGCOUTPUTLERRLEXER_HPP
